// Author: Torsten.Leitner@email.de
// (c) 2006/2007

// AU-ified 2507207

#include "tArrayComplex2D_rt.h"

using namespace std;
// CONSTRUKTORs	
tArrayComplex2D_rt:: tArrayComplex2D_rt()
{
	Nr	= 0;
	Ntw	= 0;
	dr  = 0;
	rmax= 0;
	rmin= 0;
	dw  = 0;
	wmax= 0;
	wmin= 0;
	dt  = 0;
	tmax= 0;
	tmin= 0;

}

tArrayComplex2D_rt:: tArrayComplex2D_rt(int inNr, int inNtw)
{
	init(inNr,inNtw);
}

tArrayComplex2D_rt:: tArrayComplex2D_rt(const int inNr,const double inRmax,const int inNtw,const double inWmax)
{
	init(inNr,inRmax,inNtw,inWmax);
}
/////////////////////////////////////////////////////////////

// DESTRUKTORs
tArrayComplex2D_rt::~tArrayComplex2D_rt()
{
}
/////////////////////////////////////////////////////////////

//
//	erstelle 2 versch. inits einmal wird mit omegamin/max initialisiert, und s andre mal wird sich auf die zeit bezogen
//  besser anderen namen als init, wg missverstaendnissen... evtl. SetOmega und SetTime anbieten ...
// Init koennte nur Nr,Ntw setzen, da zum prinzipiellen betrieb die koordinaten nicht notwendig sind ... (nur f Ausgabe und evolve(omega)
// -> Init(Nr,Ntw);Init(Nr,Ntw,dr); SetRadiusVector(dr); 
//    SetOmegaVector(dw,wmin); SetTimeVector(dt,tmin); --> jeweils die anderen Params.berechnen und setzten
// Init_Time (Nr,Ntw,dr,tmin,dt); -> Init+SetTimeVector
// Init_Omega(Nr,Ntw,dr,tmin,dt); -> Init+SetOmegaVector  

// bei normalen init auch dr,dt,dw,etc =0 setzen, damit kein schmarrn drinsteht...

int tArrayComplex2D_rt::SetCustomOmega(int inNtw, double inwmin, double inwmax)
{
	Ntw  = inNtw;
	wmin = inwmin;
	wmax = inwmax;


return 0;
}


int tArrayComplex2D_rt::init(int inNr, int inNtw)
{
	
	Nr 	= inNr;
	Ntw	= inNtw;
	dr  = 0;
	rmax= 0;
	rmin= 0;
	dw  = 0;
	wmax= 0;
	wmin= 0;
	dt  = 0;
	tmax= 0;
	tmin= 0;
	
	data  = new Complex* [Nr];	
	for (ir=0;ir<Nr;ir++) 	{ 
		data[ir] = new Complex [Ntw];
		for (jt=0;jt<Ntw;jt++) { data[ir][jt] = Complex(0,0); }  
	}
	
	fft1d.init(Ntw);
	
	return 0;
}

int tArrayComplex2D_rt::init(int inNr, double inRmax, int inNtw, double inWmax)
{
	
	Nr 	= inNr;
	Ntw	= inNtw;
	
//	cout << " Set radius vector ..." << endl;
	rmax= inRmax*meter_SItoAU;
//cout << "rmax "<< rmax <<endl;
	rmin= 0;
	dr	= rmax/(Nr-1);
	
	if (Nr<=1) { radius = &rmax; }
	else {radius = new double [Nr];	for (ir=0;ir<Nr;ir++) { radius[ir] = ir*dr; } }


/*//   ***   Set OMEGA- and TIME-Vector   ***

  N  =  even ! --> t=0 is not existent ...

 kc  =  kmax = N/2
wNyq = wmax = -wmin = 2PI /(2*dt)
 dw  = (wmax-wmin)/N = 2*wmax/N = 2PI/(N*dt)

 dt  = 2PI/(N*dw) ; cause of FFT-Nyquist-Theorem
 dt  = T/(N-1) = (tmax-tmin)/N-1  ; cause of N Points in T

tmax = (N-1)*dt - tmin;

If: tmax =: tm := -tmin -->  tm = (N-1)*dt / 2

t[0] = -tm = tmin ..... t[k] = -tm + k*dt .... t[N-1] = -tm + (N-1)*dt = -tm +2*tm = tm = tmax
w[0] = 0 ... w[1] = dw ... w[k<(N/2)] = k*dw ... w[k=(N/2)] = (+/-)wNyq ... w[k>(N/2)] = (k-N)*dw ... w[N-1] = -dw



*** EXAMPLE: ***

N = 8 ,  dt = 2PI  -->  wm = 1/2, dw = 1/8  , tm = (8-1)*2PI/2 = 7PI
        
        k  =    0    |   1  |   2  |   3  |      4      |   5  |   6  |   7   ||
      --------------------------------------------------------------------------------------
      w[k] =    0    | +1/8 | +2/8 | +3/8 |  (+/-) 1/2  | -3/8 | -2/8 | -1/8  ||
      --------------------------------------------------------------------------------------
      t[k] =  -7PI   | -5PI | -3PI | - PI |    + PI     | +3PI | +5PI | +7PI  ||  --> no k, so that t[k]=0, because of even N


//*/// ***   ***   ***   ***   ***   ***   ***



	time   = new double [Ntw];
	omega  = new double [Ntw];
// omega-interval determines t-interval
	 	   wmax =  inWmax * omega_SItoAU;
//cout << "wmax "<< wmax <<endl;
	 	   dw   =  2*wmax / (Ntw) ;
		   wmin = -wmax +dw ;
  ////////
	     dt   =  2*PI / (Ntw*dw); // see Nyquist-Theorem or above ...
	     tmin = -dt*0.5*(Ntw-1);
	     tmax = -tmin;
//cout << "tmax "<< tmax <<endl;

// tranfer omega and time to AtomicUnits
// this transfer has to be after the Nyquist stuff, because the fraction between time and omega is not conserved in au
//	 	   wmax *= omega_SItoAU;
//		   wmin *= omega_SItoAU;
//	 	   dw   *= omega_SItoAU;
  ////////
//cout << "wmax "<< wmax <<endl;
//	     dt   *=  time_SItoAU; 
//	     tmin *=  time_SItoAU; 
//	     tmax *=  time_SItoAU; 
//cout << "tmax "<< tmax <<endl;

//*/////    

	double ww=0 ,  tt= tmax; tt = tmin;  /// tt zweimal belegt, wegen nerviger warnmeldung... kann wieder raus !!!
	for (jt=0;jt<=int(Ntw/2);jt++) {
	    	omega[jt] = ww;  
        	time[jt]  = tt;  			
		ww+=dw;tt+=dt;			
	}
	ww = wmin; //-omega[int(Ntw/2)-1]; 
	for (jt=1+int(Ntw/2);jt<Ntw;jt++) {
   	        omega[jt] = ww;  
        	time[jt]  = tt;  
		ww+=dw;tt+=dt;			
	} 
/// ***** END of omega- and time-vector initialization



////  Initialize DATA-Array with ComplexZero = 0+0i
	
	if (Nr<=1) { data = new Complex* [2] ; }
	else { 
		data  = new Complex* [Nr];	
		for (ir=0;ir<Nr;ir++) 	{ 
			data[ir] = new Complex [Ntw];
			for (jt=0;jt<Ntw;jt++) { data[ir][jt] = Complex(0,0); }  
		}
	}
	
	fft1d.init(Ntw);
	
	return 0;
}


//*
int tArrayComplex2D_rt::fft()
{
	for (ir=0;ir<Nr;ir++) {  fft1d.fft(data[ir]); } 			//% Calc Ew1
	return 0;
}
//*/

//*
int tArrayComplex2D_rt::ifft()
{
	for (ir=0;ir<Nr;ir++) {  fft1d.ifft(data[ir]); } 			//% Calc Et1
	return 0;
}
//*/

// ****   Versch. Methoden um an Daten zu kommen ...
double tArrayComplex2D_rt::power(int ir, int jt)
{
return data[ir][jt].real() * data[ir][jt].real() + data[ir][jt].imag() * data[ir][jt].imag();
}

double tArrayComplex2D_rt::abs(int ir, int jt)
{
return sqrt(power(ir,jt));
}

Complex tArrayComplex2D_rt::at(int ir, int jt)
{
return data[ir][jt];
}

double tArrayComplex2D_rt::real(int ir, int jt)
{
return data[ir][jt].real();
}

double tArrayComplex2D_rt::imag(int ir, int jt)
{
return data[ir][jt].imag();
}

// output converted from AU to SI ************

double tArrayComplex2D_rt::powerSI(int ir, int jt)
{
return VperM_AUtoSI*VperM_AUtoSI*( data[ir][jt].real() * data[ir][jt].real() + data[ir][jt].imag() * data[ir][jt].imag() );
}

double tArrayComplex2D_rt::intensity(int ir, int jt) // [W/cm2]
{
// LIGHTSPEED	   =  299792458;        //  [ m/s ]
// EPSILON_ZERO   =  8.854187817e-12;  //  [ F/m ]

// I[W/m2] =  EPSILON_ZERO * LIGHTSPEED * |E|^2 
// I[W/cm2] =  1e-4 * I[W/m2]
// in SI: return   ( 1e-4 * 8.854187817e-12 * 299792458 * power(ir,jt)[au^2] ); 
return   ( 1e-4 * 8.854187817e-12 * 299792458 * ( VperM_AUtoSI*VperM_AUtoSI*power(ir,jt) ) ); 
}

double tArrayComplex2D_rt::absSI(int ir, int jt)
{
return sqrt(powerSI(ir,jt));
}

Complex tArrayComplex2D_rt::atSI(int ir, int jt)
{
return VperM_AUtoSI*data[ir][jt];
}
double tArrayComplex2D_rt::realSI(int ir, int jt)
{
return VperM_AUtoSI*data[ir][jt].real();
}

double tArrayComplex2D_rt::imagSI(int ir, int jt)
{
return VperM_AUtoSI*data[ir][jt].imag();
}

double tArrayComplex2D_rt::radiusSI(int ir)
{
return meter_AUtoSI*radius[ir];
}

double tArrayComplex2D_rt::timeSI(int jt)
{
return time_AUtoSI*time[jt];
}

double tArrayComplex2D_rt::omegaSI(int jt)
{
return omega_AUtoSI*omega[jt];
}
// ********************************************	


double tArrayComplex2D_rt::phi(int ir, int jt)
{
return arg( data[ir][jt] );
}

double tArrayComplex2D_rt::phase(int ir, int jt)
{
return arg( data[ir][jt] );
}



